{$R+}
Program h; uses dos;
{Pokaz. sektsii v ELF-fajle.
 Tekushch. sost.: pri analize sektsii DYNAMIC uzhe vydajot,
  kakie biblioteki trebujutsa.
  Obnar.: esli srezana SHT, dann. prog. ne sposobna prointerpret. inf.,
  dostupnuju zagruzchiku cherez PHT; zhelatel`no peredelat`, chtoby
  izvlekalo, chto mozhno, i pri ots. SHT.
}

 var b:file of byte;
 var n1,n2,n3,n4,c1,c2,c3,c4:byte; v2:word; v4:longint;
 var p:longint;
 var al:boolean;

 procedure ust0(sme:longint); begin seek(b,sme); end;

 type s2=string[2]; s4=string[4]; s8=string[8];
 function sb(c:byte):s2;
  const s:array[0..15] of char='0123456789ABCDEF';
 begin sb:=s[c div 16]+s[c mod 16]; end;
 function sw(c:word):s4;
 begin sw:=sb(hi(c))+sb(lo(c)); end;

 function sl(c:longint):s8;
  const a:longint=65536;
  var ss:s8;
  var w:array[1..2] of word; cc:longint absolute w;
  {sposob bez absolute -> nevern. rezul`t na $BFF72DEF}
 begin
 (*
  if c>=0 then begin ss:=sw(c div a)+sw(c mod a); end else begin
   c:=c-$80000000;
   ss:=sw(c div a)+sw(c mod a);
   val(copy(ss,1,1),b,kod); if kod<>0 then begin writeln('sl !!!'); halt; end;
   str(b+8:1,sss); ss:=sss+copy(ss,2,7);
  end;
 *)
  cc:=c;
  ss:=sw(w[2])+sw(w[1]);
  sl:=ss;
 end;

 function h1(sme:longint):byte; var n1:byte;
 begin
  ust0(sme); read(b,n1); h1:=n1;
 end;
 function h2(sme:longint):word; const l1:longint=1; var n1,n2:byte;
 begin
  ust0(sme); read(b,n1,n2); 
  h2:=l1*n2*256+n1;
 end;
 function h4(sme:longint):longint; const l1:longint=1; var n1,n2,n3,n4:byte;
 begin
  ust0(sme); read(b,n1,n2,n3,n4); h4:=((l1*n4*256+n3)*256+n2)*256+n1;
 end;

 function obrc(c:byte):char; var c1:char;
 begin
  if (c<$20) or (c>=$FF) then c1:='.' else c1:=chr(c); obrc:=c1;
 end;

 procedure izobr(base,sme:longint; typ:byte; comment:string);
  const l1:longint=1; {n1..n4,v2,v4 - v gol. prog. dl`a posled. ispol`z.}
 begin
  write(sl(base),' ',sl(sme),' ',sl(base+sme),' ');
  ust0(base+sme);
  case typ of
   1: begin
         read(b,n1);
         write('      ',sb(n1),'    ',obrc(n1),' ',n1:9);
        end;
   2: begin
         read(b,n1,n2); v2:=l1*n2*256+n1;
         write('    ',{sw(v2),}sb(n1),sb(n2),'   ',obrc(n1),obrc(n2),' ',v2:9);
        end;
   4: begin
         read(b,n1,n2,n3,n4); v4:=((l1*n4*256+n3)*256+n2)*256+n1;
         write({sl(v4),}sb(n1),sb(n2),sb(n3),sb(n4),' ',
           obrc(n1),obrc(n2),obrc(n3),obrc(n4),' ',v4:9);
        end;
   else begin write('typ=',typ,' - ?; '); end;
  end {case};
  writeln(' ',comment);
 end;

 {--------------------}

 var p0,entry_point,p_PHT,p_SHT,l2,p_NST:longint;
 var w1,w2,r_PHT,n_PHT,r_SHT,n_SHT,i_NST:word;
 const l1:longint=1;

 procedure stro(p:longint; nmax:integer);
  var i:integer; ende:boolean; c1:byte;
 begin
  seek(b,p); ende:=false;
  for i:=1 to nmax do begin
   if not ende then begin
    read(b,c1); if c1<>0 then write(obrc(c1)) else write(' ');
   end else begin
    write('.');
   end;
   ende:=ende or (c1=0) or eof(b);
  end;
 end;

 procedure stroki(p0,p1:longint); var s:string; c:byte; p:longint;
 begin
  writeln;
  s:=''; seek(b,p0); p:=p0;
  while filepos(b)<p1 do begin
   read(b,c); if {c<>0}c>=$20 then s:=s+chr(c);
   if (c=0) and (s<>'') then begin
    writeln(sl(p-p0),' ',s); s:=''; p:=filepos(b);
   end;
  end;
  writeln;
 end;

 procedure elty(p0,p1,l:longint); var i,j:word; c:byte;
 begin
  writeln;
  seek(b,p0); i:={0}1;
  while filepos(b)<p1 do begin
   write(i:4,' ');
   for j:=1 to l do begin
    read(b,c); write(sb(c));
    if (j mod 4)=0 then write(' ');
   end;
   writeln;
   i:=i+1;
  end;
  writeln;
 end;

 {----------------}

 type prog_header=record
  type_,offset,vaddr,paddr,filesz,memsz,flags,align:longint;
 end;
 type prog_header_=array[1..8] of longint;
 var PH:prog_header; PH_:prog_header_ absolute PH;
 const tipy__:array[0..6] of s8=(
   'NULL    ','LOAD    ','DYNAMIC ','INTERP  ',
   'NOTE    ','<reserv>','PHDR    ');
 var prog_header_tab:array[0..$10] of prog_header;

 procedure anal_prog_header_table;
  var i,j:integer;
 begin
  writeln('Prog. Header Table: ',sw(r_PHT),' ',sw(n_PHT),' ',
    sl(p_PHT),'-',sl(p_PHT+r_PHT*n_PHT)); writeln;

  writeln(' Nr VirtAdr  PhysOfs           Tip');
  for i:=0 to n_PHT-1 do with prog_header_tab[i] do begin
   write(' ',sb(lo(i)),' ');
   for j:=1 to (r_PHT div 4) do PH_[j]:=h4(p_PHT+(i)*r_PHT+(j-1)*4);
   prog_header_tab[i]:=PH;
   write(sl(vaddr),' ');
   write(sl(offset),'-',sl(offset+filesz),' ');
   if (type_>=0) and (type_<=6) then write(tipy__[type_])
     else write(sl(type_));
   writeln;
  end {i};
  writeln;

  writeln(' Nr type_    vaddr    paddr    filesz   memsz    flags    align');
  for i:=0 to n_PHT-1 do with prog_header_tab[i] do begin
   write(' ',sb(lo(i)),' ');
   PH:=prog_header_tab[i];
   if (type_>=0) and (type_<=6) then write(tipy__[type_],' ')
     else write(sl(type_),' ');
   for j:=1 to 8 do begin
    if j<=2 {type_, offset} then
    else if (j=4) and (PH_[4]=PH_[3]) then write('........ ')
    else if (j=6) and (PH_[6]=PH_[5]) then write('........ ')
    else write(sl(PH_[j]),' ');
   end;
   writeln;
  end {i};
  writeln;

 end;

 {----------------}

 type sect_header=record
  name,type_,flags,addr,offset,
    size,link,info,addralign,entsize:longint;
  {"name" is an index into the section header String Table Section}
  ende:longint;
 end;
 type sect_header_=array[1..10] of longint;
 var SH:sect_header; SH_:sect_header_ absolute SH;
 {type s8=string[8];} {uzhe opr.}
 const tipy_:array[0..11] of s8=(
   'NULL    ','PROGBITS','SYMTAB  ','STRTAB  ',
   'RELA    ','HASH    ','DYNAMIC ','NOTE    ',
   'NOBITS  ','REL     ','<reserv>','DYNSYM  ');
 var sect_header_tab:array[0..$40] of sect_header;

 procedure symbol_tab(this_sec:integer; p0,p1:longint);
  var i,sect_names,sect_dupa:word; c,info,other:byte;
  var nam,val,siz,ofs_names:longint;
 begin
  writeln;
  sect_names:=sect_header_tab[this_sec].link;
  ofs_names:=sect_header_tab[sect_names].offset;
  writeln('  Nr   info    name                             ',
    'val      siz      dupa');
  for i:=1 to ((p1-p0) div 16) do begin write(sw(i-1),' ');
   nam:=h4(p0+(i-1)*16);
   val:=h4(p0+(i-1)*16+4);
   siz:=h4(p0+(i-1)*16+8);
   info:=h1(p0+(i-1)*16+12);
   other:=h1(p0+(i-1)*16+13); if other<>0 then writeln('!!!');
   sect_dupa:=h2(p0+(i-1)*16+14);
   c:=info div 16;
   if c=0 then write('loc  ')
     else if c=1 then write('glob ')
     else if c=2 then write('weak ')
     else write(sb(c),'  ');
   c:=info mod 16;
   if c=0 then write(' -   ')
     else if c=1 then write('obj  ')
     else if c=2 then write('func ')
     else if c=3 then write('sect ')
     else if c=4 then write('file ')
     else write(sb(c),'  ');
   stro(ofs_names+nam,32); write(' ');
   write(sl(val),' ',sl(siz),' ',sw(sect_dupa));
   writeln;
  end;
  writeln;
 end;

 procedure rel_tab(this_sec:integer; p0,p1:longint);
 {anal. tablitsy nastroek}
  var i,j,sect_names,sect_dupa:word; c:byte;
  var adr,info_,index,siz,nr_tab_simv,nr_dupy,ofs_names,nam:longint; tip:byte;
 begin
  writeln;
  nr_tab_simv:=sect_header_tab[this_sec].link;
  nr_dupy:=sect_header_tab[this_sec].info;
  write('   otnos. k sekcii ',sw(lo(nr_dupy)),' (');
  stro(p_NST+sect_header_tab[nr_dupy].name,8);
  write('); tab. simv. - sekcija ',sw(lo(nr_tab_simv)),' (');
  stro(p_NST+sect_header_tab[nr_tab_simv].name,8);
  writeln(').'); writeln;
  sect_names:=sect_header_tab[nr_tab_simv].link;
  ofs_names:=sect_header_tab[sect_names].offset;
  siz:=sect_header_tab[this_sec].entsize;
  if siz<>8 then writeln('Predupr.: siz=',siz,' - <>8 !!!');
  writeln('  Nr adr     tip index  imya');
  for i:=1 to ((p1-p0) div siz) do begin write((i-1):4,' ');
   adr:=h4(p0+(i-1)*siz); write(sl(adr),' ');
   info_:=h4(p0+(i-1)*siz+4); tip:=info_ mod 256; index:=info_ div 256;
   write(sb(tip),' ',
     sb((index div 256) div 256),
     sb((index div 256) mod 256),
     sb(index mod 256),' ');
   for j:=9 to siz do begin
    read(b,c); write(sb(c)); if (j mod 4)=0 then write(' ');
   end;
   nam:=h4(sect_header_tab[nr_tab_simv].offset+index*16);
   stro(ofs_names+nam,24);
   writeln;
  end {i};
  writeln;
 end;

 procedure va_sec(inf_va:longint; var nr:word; var imya:s8);
 {nakh. sektsii po virt. adresu jejo nachala}
  var i,n:integer; gef,end_nam:boolean; c:char; s:s8;
  label ende;
 begin
  gef:=false; for i:=0 to n_SHT-1 do begin
   if sect_header_tab[i].addr=inf_va then begin gef:=true; goto ende; end;
  end;
  ende:
  if gef then begin
   nr:=i;
   n:=sect_header_tab[i].name;
   end_nam:=false; s:=''; for i:=0 to 7 do begin
    c:=chr(h1(p_NST+n+i));
    if end_nam then c:='.' else if c=chr(0) then begin c:=' '; end_nam:=true; end;
    c:=obrc(ord(c));
    s:=s+c;
   end;
   imya:=s;
  end else begin
   nr:=0; imya:='????????';
  end;
 end;

 var dynam_tab:array[0..$40,1..2] of longint; n_dynam_tab:integer;

 procedure dynamic_tab(this_sec:integer; p0,p1:longint);
  const d_tags:array[0..23] of s8=(
    'NULL    ','NEEDED  ','PLTRELSZ','PLTGOT  ',
    'HASH    ','STRTAB  ','SYMTAB  ','RELA    ',
    'RELASZ  ','RELAENT ','STRSZ   ','SYMENT  ',
    'INIT    ','FINI    ','SONAME  ','RPATH   ',
    'SYMBOLIC','REL     ','RELSZ   ','RELENT  ',
    'PLTREL  ','DEBUG   ','TEXTREL ','JMPREL  ');
  var i,j:integer; nr,jj:word; imya:s8; info,inf_va,jjj:longint; c:byte;
  label ende;
 begin
  writeln;
  i:=-1; repeat i:=i+1;
   dynam_tab[i,1]:=h4(p0+i*8); dynam_tab[i,2]:=h4(p0+i*8+4);
  until dynam_tab[i,1]=0;
  n_dynam_tab:=i;
  i:=0; repeat write(sb(lo(i)),' ');
   info:=dynam_tab[i,1]; inf_va:=dynam_tab[i,2];
   if (info>=0) and (info<=23) then write(d_tags[info],' ')
     else write(sl(info),' ');
   write(sl(inf_va),' ');
   if info=0 {NULL = prizn. konca} then begin
   end else if info=1 {NEEDED} then begin
    for j:=0 to n_dynam_tab do if dynam_tab[j,1]=5 then begin goto ende; end;
    ende:
    {j - eto nomer el-ta v rassm. tablitse par (info, inf_va)}
    va_sec(dynam_tab[j,2],jj,imya); {write('jj=',jj:4,' ');}
    jjj:=sect_header_tab[jj].offset;
    seek(b,jjj+inf_va);
    repeat read(b,c); if c<>0 then write(obrc(c)); until c=0;
   end else if ((info>=3) and (info<=6)) or (info=12) or (info=13)
     or (info=17) or (info=23) then begin
    va_sec(inf_va,nr,imya); write(sb(lo(nr)),' ',imya,' ');
   end else write('?');
   writeln;
   i:=i+1;
  until info=0;
  writeln;
 end;

 procedure anal_note(ifict:integer; ofse,ende:longint);
  var name_siz,name_siz_,desc_siz,desc_siz_,tip,p:longint; i,j:integer; c:byte;
 begin writeln;
  p:=ofse; i:=0;
  while p<ende do begin
   name_siz:=h4(p); desc_siz:=h4(p+4); tip:=h4(p+8);
   write(sw(i),' ',sl(name_siz),' ',sl(desc_siz),' ',sl(tip),' ');
   if (name_siz mod 4)=0 then name_siz_:=name_siz
     else name_siz_:=4*((name_siz div 4)+1);
   if (desc_siz mod 4)=0 then desc_siz_:=desc_siz
     else desc_siz_:=4*((desc_siz div 4)+1);
   for j:=1 to name_siz do begin read(b,c); write(obrc(c)); end;
   for j:=name_siz+1 to 16 do write(' '); write(' ');
   p:=p+12+name_siz_; seek(b,p);
   for j:=1 to desc_siz do begin read(b,c); write(sb(c)); end;
   for j:=desc_siz+1 to 8 do write('  ');
   p:=p+12+name_siz_+desc_siz_; seek(b,p);
   writeln; i:=i+1;
  end;
  writeln;
 end;

 procedure anal_section_header_table;
  type s9=string[9];
  const tipy:array[1..10] of s9=(
    'name     ','type     ','flags    ','addr     ','offset   ',
    'size     ','link     ','info     ','addralign','entsize  ');
  var i,j,k:integer;
 begin
  writeln('Sect. Header Table: ',sw(r_SHT),' ',sw(n_SHT),' ',
    sl(p_SHT),'-',sl(p_SHT+r_SHT*n_SHT)); writeln;

  {1-j prokhod: vyv. virt. adres, polozh. v fajle, nazv., tip, soderzh.}
  write(' Nr VirtAdr  PhysOfs           ');
  if al then write('Size      ');
  writeln('Imya          Tip      Soderzh.');
  for i:=0 to n_SHT-1 do begin
   with sect_header_tab[i] do begin
    write(' ',sb(lo(i)),' ');
    for j:=1 to 10 do SH_[j]:=h4(p_SHT+(i)*r_SHT+(j-1)*4);
    sect_header_tab[i]:=SH;
    ende:=offset+size;
    write(sl(addr),' ',sl(offset),'-',sl(ende),' ');
    if al then write(sl(size),' ');
    stro(p_NST+name,14); write(' ');
    if SH_[2]>11 then write(sl(SH_[2]),' ')
      else write(tipy_[SH_[2]],' ');
    seek(b,offset);
    for j:=1 to 4 do if j<=size then begin
     read(b,c1); write(sb(c1));
    end else write('  ');
    write(' ');
    seek(b,offset);
    for j:=1 to 14 do if j<=size then begin
     read(b,c1); write(obrc(c1));
    end else write(' ');
    writeln;
   end {with};
  end {i:=0 to n_SHT-1};

  writeln; l2:=filesize(b); writeln('filesize=',sl(l2)); writeln;

  {2-j prokhod - bolee detal`n.}
  for k:=1 to 13 do write(' ');
  for j:={1}2 to 10 do write(copy(tipy[j],1,8),' ');
  writeln;
  for i:=0 to n_SHT-1 do begin
   with sect_header_tab[i] do begin
    write(' ',sb(lo(i)),' ');
    stro(p_NST+name,8); write(' ');
    SH:=sect_header_tab[i];
    for j:={1}2 to 10 do begin
     if j<>2 then write(sl(SH_[j]),' ') else begin
      if SH_[j]<=11 then write(tipy_[SH_[j]],' ') else write(sl(SH_[j]),' ');
     end;
    end;
    writeln;
    if (type_=3) {STRTAB} and al then begin
     stroki(offset,ende);
    end else if (type_=2) or (type_=11) {SYMTAB ili DYNSYM} then begin
     if (entsize<>$10) then writeln('entsize=',entsize,' !!!');
     symbol_tab(i,offset,ende);
    end else if (type_=4) or (type_=9) {RELA, REL} then begin
     rel_tab(i,offset,ende);
    end else if type_=6 {DYNAMIC} then begin
     dynamic_tab(i,offset,ende);
    end else if (type_=7) {NOTE} and al then begin
     anal_note(i,offset,ende);
    end else if (entsize<>0) and al {tabl. iz el-tov dliny entsize} then begin
     elty(offset,ende,entsize);
    end;
   end {with};
  end {i:=0 to n_SHT-1};
  writeln;

 end;

 {----------------}

Begin
 if (paramcount<1) or (paramcount>2) then begin
  writeln('Obr.: prog infile [/a]; /a - all info.'); halt;
 end;
 if (paramcount=2) and (paramstr(2)<>'/a') then begin
  writeln('paramstr(2)=',paramstr(2),' - traktuem kak /a.');
 end;
 al:=paramcount=2;
 writeln;
 writeln('                  ',paramstr(1):12,' ');
 writeln;
 {--------}
 Assign(b,ParamStr(1));
 {GetFAttr(b,attr); if attr and ReadOnly<>0 then SetFAttr(b,Archive);}
 filemode:=0; reset(b);
 read(b,c1,c2,c3,c4);
 if not ( (c1=$7F) and (c2=ord('E')) and (c3=ord('L')) and (c4=ord('F')) )
   then begin
  writeln('<',obrc(c1),obrc(c2),obrc(c3),obrc(c4),' - ne .ELF>'); halt;
 end;
 p0:=0;
 c1:=h1(p0+4); if c1<>1 then writeln('h1(4)=',sb(c1),' - ne 32-b.!!!');
 c1:=h1(p0+5); if c1<>1 then writeln('h1(5)=',sb(c1),' - ne s mladsh.!!!');
 {--------}
 w1:=h2(p0+$10); if al then writeln('type=',sw(w1),' (1 - relo, 2 - exe, 3 - obj, ...)');
 w1:=h2(p0+$12); if w1<>3 then writeln('machine=',sw(w1),' - ne 80386 !!!');
 l2:=h4(p0+$14); if l2<>l1 then writeln('version=',sl(l2));
 entry_point:=h4(p0+$18); writeln('entry_point (virt.): ',sl(entry_point));
 p_PHT:=h4(p0+$1C); write('p_PHT=',sl(p_PHT));
 if p_PHT<>$34 then write(' - neobychn.!!!');
 writeln;
 p_SHT:=h4(p0+$20); writeln('p_SHT=',sl(p_SHT));
 w2:=h2(p0+$28); if w2<>$34 then writeln('Razmer ELF-headera: ',sw(w2),' - neobychn.!!!');
 {--------}
 writeln;
 if p_PHT=0 then writeln(' Otsutstv. prog. header table.') else begin
  {vozm. li, chto bajty - ne po 4 ?}
  r_PHT:=h2(p0+$2A); n_PHT:=h2(p0+$2C);
  anal_prog_header_table;
 end;
 writeln('--------');
 {--------}
 writeln;
 if p_SHT=0 then writeln(' Otsutstv. sect. header table.') else begin
  i_NST:=h2(p0+$32); writeln('i_NST=',sw(i_NST));
  {nomer sekc., sod Name String Table; predp., chto numeraciq - ot 0 !}
  r_SHT:=h2(p0+$2E); n_SHT:=h2(p0+$30);
  if r_SHT<>40 then writeln('r_SHT<>40 - !!!');
  {tabl. sekcij - dlina zapisi i chislo zapisej}
  p:=p_SHT+r_SHT*i_NST; {ukaz. na zapis` o sektsii NST}
  p_NST:=h4(p+16);
  writeln('p_NST=',sl(p_NST));
  writeln;
  anal_section_header_table;
 end;
 writeln; writeln('-------------');
 {--------}
 close(b);
End.
