{$R+}
Program h; uses dos;
{Popytki analiza *.elf pri nalichii tk. PHT (t.e. pri ots. SHT);
  probl. - net dokumentir. sposoba nah. konec tablicy SYMTAB .
  Na `/bin/ftp' -> est` ss. za predely zagruv.`asti!
}

 var b:file of byte;
 var n1,n2,n3,n4,c1,c2,c3,c4:byte; v2:word; v4:longint;
 var i,j:integer;
 var al:boolean;
 var p_SHT,p_strtab,p_symtab:longint;
 var p0,entry_point,p_entry,p_PHT,l2:longint;
 var w1,w2,r_PHT,n_PHT:word;
 const l1:longint=1;

 procedure ust0(sme:longint); begin seek(b,sme); end;

 type s2=string[2]; s4=string[4]; s8=string[8];
 function sb(c:byte):s2;
  const s:array[0..15] of char='0123456789ABCDEF';
 begin sb:=s[c div 16]+s[c mod 16]; end;
 function sw(c:word):s4;
 begin sw:=sb(hi(c))+sb(lo(c)); end;

 function sl(c:longint):s8;
  const a:longint=65536;
  var ss:s8;
  var w:array[1..2] of word; cc:longint absolute w;
  {sposob bez absolute -> nevern. rezul`t na $BFF72DEF}
 begin
 (*
  if c>=0 then begin ss:=sw(c div a)+sw(c mod a); end else begin
   c:=c-$80000000;
   ss:=sw(c div a)+sw(c mod a);
   val(copy(ss,1,1),b,kod); if kod<>0 then begin writeln('sl !!!'); halt; end;
   str(b+8:1,sss); ss:=sss+copy(ss,2,7);
  end;
 *)
  cc:=c;
  ss:=sw(w[2])+sw(w[1]);
  sl:=ss;
 end;

 function h1(sme:longint):byte; var n1:byte;
 begin
  ust0(sme); read(b,n1); h1:=n1;
 end;
 function h2(sme:longint):word; const l1:longint=1; var n1,n2:byte;
 begin
  ust0(sme); read(b,n1,n2);
  h2:=l1*n2*256+n1;
 end;
 function h4(sme:longint):longint; const l1:longint=1; var n1,n2,n3,n4:byte;
 begin
  ust0(sme); read(b,n1,n2,n3,n4); h4:=((l1*n4*256+n3)*256+n2)*256+n1;
 end;

 function obrc(c:byte):char; var c1:char;
 begin
  if (c<$20) or (c>=$FF) then c1:='.' else c1:=chr(c); obrc:=c1;
 end;

 procedure izobr(base,sme:longint; typ:byte; comment:string);
  const l1:longint=1; {n1..n4,v2,v4 - v gol. prog. dl`a posled. ispol`z.}
 begin
  write(sl(base),' ',sl(sme),' ',sl(base+sme),' ');
  ust0(base+sme);
  case typ of
   1: begin
         read(b,n1);
         write('      ',sb(n1),'    ',obrc(n1),' ',n1:9);
        end;
   2: begin
         read(b,n1,n2); v2:=l1*n2*256+n1;
         write('    ',{sw(v2),}sb(n1),sb(n2),'   ',obrc(n1),obrc(n2),' ',v2:9);
        end;
   4: begin
         read(b,n1,n2,n3,n4); v4:=((l1*n4*256+n3)*256+n2)*256+n1;
         write({sl(v4),}sb(n1),sb(n2),sb(n3),sb(n4),' ',
           obrc(n1),obrc(n2),obrc(n3),obrc(n4),' ',v4:9);
        end;
   else begin write('typ=',typ,' - ?; '); end;
  end {case};
  writeln(' ',comment);
 end;

 {---------------------}

 procedure show_(p:longint);
 begin
  ust0(p); for j:=1 to 4 do begin read(b,c1); write(sb(c1)); end;
  write(' ');
  ust0(p); for j:=1 to 16 do begin read(b,c1); write(obrc(c1)); end;
  write(' ');
 end;
 procedure show_str(p:longint);
 begin
  ust0(p); repeat read(b,c1); if c1<>0 then write(obrc(c1)); until c1=0;
  write(' ');
 end;
 procedure show_hex(p:longint; n:integer);
 begin
  ust0(p); for j:=1 to n do begin
   if not eof(b) then begin
    read(b,c1); write(sb(c1));
   end else begin
    write('!!');
   end;
  end;
  write(' ');
 end;

 procedure stro(p:longint; nmax:integer);
  var i:integer; ende:boolean; c1:byte;
 begin
  seek(b,p); ende:=false;
  for i:=1 to nmax do begin
   if not ende then begin
    read(b,c1); if c1<>0 then write(obrc(c1)) else write(' ');
   end else begin
    write('.');
   end;
   ende:=ende or (c1=0) or eof(b);
  end;
 end;

 procedure stroki(p0,p1:longint); var s:string; c:byte; p:longint;
 begin
  writeln;
  s:=''; seek(b,p0); p:=p0;
  while filepos(b)<p1 do begin
   read(b,c); if {c<>0}c>=$20 then s:=s+chr(c);
   if (c=0) and (s<>'') then begin
    writeln(sl(p-p0),' ',s); s:=''; p:=filepos(b);
   end;
  end;
  writeln;
 end;

 procedure elty(p0,p1,l:longint); var i,j:word; c:byte;
 begin
  writeln;
  seek(b,p0); i:={0}1;
  while filepos(b)<p1 do begin
   write(i:4,' ');
   for j:=1 to l do begin
    read(b,c); write(sb(c));
    if (j mod 4)=0 then write(' ');
   end;
   writeln;
   i:=i+1;
  end;
  writeln;
 end;

 {----------------}

 type prog_header=record
  type_,offset,vaddr,paddr,filesz,memsz,flags,align:longint;
 end;
 type prog_header_=array[1..8] of longint;
 var PH:prog_header; PH_:prog_header_ absolute PH;
 const tipy__:array[0..6] of s8=(
   'NULL    ','LOAD    ','DYNAMIC ','INTERP  ',
   'NOTE    ','<reserv>','PHDR    ');
 var PHT:array[0..$10] of prog_header;

 function virt2phys(l:longint):longint;
  var jmae,j,i:integer; pmae,p:longint;
 begin
  p:=-1; j:=-1; {k:=-1; pp:=-1;}
  for i:=0 to n_PHT-1 do with PHT[i] do begin
   {writeln(sl(vaddr),' ',sl(offset),' ',sl(filesz),' - ',sl(l));}
   {if vaddr>pp then begin k:=i; pp:=vaddr; end;}
   if (l>=vaddr) and (l<vaddr+filesz) then begin
    pmae:=p; jmae:=j; p:=offset+(l-vaddr); j:=i;
    if (jmae<>-1) and (p<>pmae) then begin
     writeln('virt2phys: jmae,j,l=',jmae:4,j:4,' ',sl(l),' - neodnozn.!!!');
    end;
   end;
  end;
  {if j=-1 then with PHT[k] do p:=offset+(l-vaddr);}
  {inogda bywaet nebol`shoe wylezanie; wozm., lu`[e sohr. p=-1
    i ne wywodit` takoe, no poprobuem wywesti.
  }
  virt2phys:=p;
 end;

 procedure anal_prog_header_table;
  var i,j:integer;
 begin
  writeln('Prog. Header Table: ',sw(r_PHT),' ',sw(n_PHT),' ',
    sl(p_PHT),'-',sl(p_PHT+r_PHT*n_PHT)); writeln;
  writeln(' Nr VirtAdr  PhysOfs           Tip');
  for i:=0 to n_PHT-1 do with PHT[i] do begin
   write(' ',sb(lo(i)),' ');
   for j:=1 to (r_PHT div 4) do PH_[j]:=h4(p_PHT+(i)*r_PHT+(j-1)*4);
   PHT[i]:=PH;
   write(sl(vaddr),' ');
   write(sl(offset),'-',sl(offset+filesz),' ');
   if (type_>=0) and (type_<=6) then write(tipy__[type_])
     else write(sl(type_));
   writeln;
  end {i};
  writeln;
 end;

 {----------------}

 procedure anal_SYMTAB(p0,p1:longint);
  var i,j,sect_dupa:word; c,info,other:byte;
  var nam,val,siz,p_func:longint;
 begin
  writeln;
  writeln('  Nr   info    name                             ',
    'val      siz      dupa');
  for i:=1 to ((p1-p0) div 16) do begin write(sw(i-1),' ');
   if al then write(sl(p0+(i-1)*16),' ');
   nam:=h4(p0+(i-1)*16);
   val:=h4(p0+(i-1)*16+4);
   siz:=h4(p0+(i-1)*16+8);
   info:=h1(p0+(i-1)*16+12);
   other:=h1(p0+(i-1)*16+13); if other<>0 then writeln('!!!');
   sect_dupa:=h2(p0+(i-1)*16+14);
   c:=info div 16;
   if c=0 then write('loc  ')
     else if c=1 then write('glob ')
     else if c=2 then write('weak ')
     else write(sb(c),'  ');
   c:=info mod 16;
   if c=0 then write(' -   ')
     else if c=1 then write('obj  ')
     else if c=2 then write('func ')
     else if c=3 then write('sect ')
     else if c=4 then write('file ')
     else write(sb(c),'  ');
   stro({ofs_names}p_strtab+nam,32); write(' ');
   write(sl(val),' ',sl(siz),' ',sw(sect_dupa));

   if (copy(sl(val),1,2)='08') and (siz>0) then begin
    j:=8; if siz<j then j:=siz;
    p_func:=virt2phys(val);
    if p_func<>-1 then begin
     write(' '); show_hex(p_func,j);
    end else begin
     write(' <Za pred.>');
    end;
   end;

   writeln;
  end;

  writeln;
 end;

 var dynam_tab:array[0..$40,1..2] of longint; n_dynam_tab:integer;

 procedure anal_DYNAMIC(p0,p1:longint);
  const d_tags:array[0..23] of s8=(
    'NULL    ','NEEDED  ','PLTRELSZ','PLTGOT  ',
    'HASH    ','STRTAB  ','SYMTAB  ','RELA    ',
    'RELASZ  ','RELAENT ','STRSZ   ','SYMENT  ',
    'INIT    ','FINI    ','SONAME  ','RPATH   ',
    'SYMBOLIC','REL     ','RELSZ   ','RELENT  ',
    'PLTREL  ','DEBUG   ','TEXTREL ','JMPREL  ');
  var i:integer; jjj,j:longint;
 begin
  writeln;
  i:=-1; repeat i:=i+1;
   dynam_tab[i,1]:=h4(p0+i*8); dynam_tab[i,2]:=h4(p0+i*8+4);
   if al then writeln(sl(dynam_tab[i,1]),' ',sl(dynam_tab[i,2]),' ');
   if dynam_tab[i,1]=5 {STRTAB} then p_strtab:=virt2phys(dynam_tab[i,2]);
   if dynam_tab[i,1]=6 {SYMTAB} then p_symtab:=virt2phys(dynam_tab[i,2]);
  until dynam_tab[i,1]=0;
  n_dynam_tab:=i;
  if not (p1=p0+(i+1)*8) then begin
   writeln('anal_DYNAMIC - podozr.: p1<>p0+(i+1)*8: ',
     sl(p0),' ',sl(p1),' ',sl(p0+(i+1)*8));
  end;
  for i:=0 to n_dynam_tab do begin
   write(sl(dynam_tab[i,1]),' ',sl(dynam_tab[i,2]),' ');
   j:=dynam_tab[i,1];
   if (j>=0) and (j<=23) then write(d_tags[j]) else write('?       ');
   if (((j>=3) and (j<=7)) or ((j>=12) and (j<=13))) or
     (copy(sl(dynam_tab[i,2]),1,2)='08') then
     begin jjj:=virt2phys(dynam_tab[i,2]); write(' ',sl(jjj),' '); show_(jjj); end;
   if j=1 {NEEDED} then begin
    write(' '); show_str(p_strtab+dynam_tab[i,2]);
   end;
   writeln;
  end;
  writeln;
 end;

 {----------------}

Begin
 if (paramcount<1) or (paramcount>2) then begin
  writeln('Obr.: prog infile [/a]; /a - all info.'); halt;
 end;
 if (paramcount=2) and (paramstr(2)<>'/a') then begin
  writeln('paramstr(2)=',paramstr(2),' - traktuem kak /a.');
 end;
 al:=paramcount=2;
 writeln;
 writeln('                  ',paramstr(1):12,' ');
 writeln;
 {--------}
 Assign(b,ParamStr(1));
 {GetFAttr(b,attr); if attr and ReadOnly<>0 then SetFAttr(b,Archive);}
 filemode:=0; reset(b);
 read(b,c1,c2,c3,c4);
 if not ( (c1=$7F) and (c2=ord('E')) and (c3=ord('L')) and (c4=ord('F')) )
   then begin
  writeln('<',obrc(c1),obrc(c2),obrc(c3),obrc(c4),' - ne .ELF>'); halt;
 end;
 p0:=0;
 c1:=h1(p0+4); if c1<>1 then writeln('h1(4)=',sb(c1),' - ne 32-b.!!!');
 c1:=h1(p0+5); if c1<>1 then writeln('h1(5)=',sb(c1),' - ne s mladsh.!!!');
 {--------}
 w1:=h2(p0+$10); if al then writeln('type=',sw(w1),' (1 - relo, 2 - exe, 3 - obj, ...)');
 w1:=h2(p0+$12); if w1<>3 then writeln('machine=',sw(w1),' - ne 80386 !!!');
 l2:=h4(p0+$14); if l2<>l1 then writeln('version=',sl(l2));
 entry_point:=h4(p0+$18); writeln('entry_point (virt.): ',sl(entry_point));
 p_PHT:=h4(p0+$1C); write('p_PHT=',sl(p_PHT));
 if p_PHT<>$34 then write(' - neobychn.!!!');
 writeln;
 p_SHT:=h4(p0+$20); writeln('p_SHT=',sl(p_SHT));
 w2:=h2(p0+$28); if w2<>$34 then writeln('Razmer ELF-headera: ',sw(w2),' - neobychn.!!!');
 {--------}
 writeln;
 if p_PHT=0 then begin
  writeln(' Otsutstv. prog. header table.'); halt;
 end;
 {vozm. li, chto bajty - ne po 4 ?}
 r_PHT:=h2(p0+$2A); n_PHT:=h2(p0+$2C);
 anal_prog_header_table;
 {--------}
 {poiskat` tochku whoda - wrode ne treb. DYNAMIC}
 p_entry:=virt2phys(entry_point);
 write('Tochka vhoda: ',sl(entry_point),' ',sl(p_entry),' -> ');
 show_hex(p_entry,8);
 writeln; writeln;
 {--------}
 j:=-1; for i:=0 to n_PHT-1 do begin
  if PHT[i].type_=2 {DYNAMIC} then j:=i;
 end;
 if j=-1 then begin writeln('Ots. DYNAMIC.'); halt; end;
 writeln('DYNAMIC: j=',j);
 with PHT[j] do anal_DYNAMIC(offset,offset+filesz);
 writeln('--------');
 {--------}
  writeln('p_symtab=',sl(p_symtab));
  if p_strtab<=p_symtab then begin
   writeln('nestandart. konec SYMTAB - prekr.rab.'); halt;
  end;
  {predp., chto srazu posle SYMTAB sleduet STRTAB;
    esli eto ne tak, to neqsno, kak opr. konec SYMTAB;
    mozhno perebr. wse adresa iz DYNAMIC i wybr. sledujushch.
    posle p_symtab, no net uwer., chto w symtab net neispolxz. hwosta!
  }
  anal_SYMTAB(p_symtab,p_strtab);
 writeln('--------');
 {--------}
 close(b);
End.
